% compute the distance of two discrete spike trains using wapring method

% f: one spike train
% g: another spike train
% T: length of the time domain
% p: parameter p in range [1, infty)
% lambda: penalty coefficient

% y: distance

function y = discre_sub(f, g, T, p, lambda)

M = length(f);
N = length(g);

cf = [0 f T];
cg = [0 g T];
isif = diff(cf);
isig = diff(cg);

% add the penality to the transformation
H = Inf*ones(M+2,N+2);

H(1,1:N+2) = 0:N+1;
H(1:M+2,1) = (0:M+1);

Q = ones(2,M,N);
S0 = [1 1 2 2 3 1 3 1 3 4 4 1 2 3 4 5 5 5 5 1 5 6 6; ...
       1 2 1 3 2 3 1 4 4 3 1 5 5 5 5 4 3 2 1 6 6 5 1]';
for i = 2:M+2
    for j = 2:N+2
%         S = [1 kron(2:i-1, ones(1,j-2)); 1 kron(ones(1,i-2), 2:j-1)]';
        S = ones(size(S0,1),1)*[i, j] - S0;
        ind = (min(S,[],2) > 1);
        S = [1 1; S(ind, :)];     
        
        clear Efg;
        for k = 1:size(S,1)
            match_dis = (i-S(k,1)-1)+(j-S(k,2)-1); 
            wp_dis = lambda*((abs((cf(i) - cf(S(k,1)))^(1/p) - (cg(j) - cg(S(k,2)))^(1/p)))^p);
            Efg(k) = match_dis + wp_dis + H(S(k,1),S(k,2));
        end
        [H(i,j), ind] = min(Efg); 
        Q(:,i,j) = S(ind,:)';  
    end
end

ph(1,:) = [M+2, N+2];       % optimal path
d = 1;
while max(ph(d,:)) > 1
    d = d+1;
    ph(d,:) = Q(:, ph(d-1,1), ph(d-1,2))';
end

for d = 1:length(ph)
    S2(d) = H(ph(d,1), ph(d,2));
end

y = H(end,end)^(1/p);

